﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Checked
{
    class Program
    {
        /*
        public static int Silnia(int argument)
        {
            int wynik = 1;
            if (argument < 2) return wynik;
            for (int i = 2; i <= argument; i++) wynik *= i;
            //for (int i = 2; i <= argument; i++) unchecked { wynik *= i; }
            //for (int i = 2; i <= argument; i++) { checked { wynik *= i; } }
            return wynik;
        }
        */

        //własność
        public static long Silnia10
        {
            get
            {
                return Silnia(10);
            }
        }

        public static long Silnia(long argument)
        {
            long wynik = 1;
            if (argument < 2) return wynik;
            //for (long i = 2; i <= argument; i++) { wynik *= i; }
            for (long i = 2; i <= argument; i++) { unchecked { wynik *= i; } }
            //for (long i = 2; i <= argument; i++) { checked { wynik *= i; } }
            return wynik;
        }

        private static void wyświetl(int n)
        {
            Console.WriteLine(n.ToString() + " - " + Silnia(n).ToString());
        }

        static void Main(string[] args)
        {
            /*
            wyświetl(0);
            wyświetl(1);
            wyświetl(2);
            wyświetl(3);
            wyświetl(5);
            wyświetl(10);
            wyświetl(15);
            wyświetl(17);
            wyświetl(50);
            wyświetl(100);
            wyświetl(150);
            wyświetl(200);
            wyświetl(500);
            wyświetl(1000);
            */

            /*
            Random r = new Random();
            long start = Environment.TickCount;
            for(int i = 0; i < 100000000; ++i) { Silnia(r.Next(10)); }
            long stop = Environment.TickCount;
            Console.WriteLine(stop - start);
            */

            //long zmienna = Silnia10;
            for (int i = 0; i < 100000000; i+=1000)
            {
                Console.WriteLine(i.ToString() + "     " + (100.0*i/int.MaxValue).ToString());
            }
        }
    }
}
